/**
    The ApplicationManager is used to manage the application itself.
    @Author Jonathan Saunders
    @Original <a href="mailto:matthewcasperson@gmail.com">Matthew Casperson</a>
    @class
*/
function ApplicationManager()
{
    this.canvasWidth = 0;
    this.canvasHeight = 0;
    
    //An array of buttons on-screen
    this.buttons = null;
    
    //A reference to the menu currently being shown (if any)
    this.menu = null;
    
    //A referemce to a Text object
    this.timer= null

    /** Initialises this object
        @param canvasWidth      The width of the canvas
        @param canvasHeight     The height of the canvas
        @return                 A reference to the initialised object */
    this.startupApplicationManager = function(canvasWidth, canvasHeight)
    {
        g_ApplicationManager = this;
        g_Copies = new Array();
        g_Records = new Array();
        this.buttons = new Array();
        this.canvasWidth = canvasWidth;
        this.canvasHeight = canvasHeight;
		
        this.openMainMenu(1);

        return this;
    }

    this.startLevel = function()
    {
        g_GameObjectManager.shutdownAll();
        this.level = new Level().startupLevel(this.canvasWidth, this.canvasHeight);
        if (g_Level == g_LastLevel)
        {
        	g_player = new FinalPlayer().startupFinalPlayer(this.level);
        	window.setTimeout(function() {var copy = new FinalCopy().startupFinalCopy(this.level);}, 4000);
        	
        }
        else {
	        g_player = new Player().startupPlayer(this.level);
	        for (i=0; i < g_Copies.length; i++)
	        {
	        	g_Copies[i].startupCopyPlayer(this.level, g_Records[i], i);
			}
	        this.timer = new Text().startupText(475, 30, "Time: ", g_Clock);
	        this.levelDisplay = new Text().startupText(75, 20, "Level: ", g_Level);
	        this.copyDisplay = new Text().startupText(75, 45, "Copies: ", g_Copies.length + "/" + this.level.passNum);
	    }
    }

    this.openMainMenu = function(type)
    {
    	this.emptyArray();
        g_GameObjectManager.shutdownAll();
        this.menu = new MainMenu().startupMainMenu(type);
        if (type == 1)
        {
        	this.addButton(g_ResourceManager.newGameButton, 1, 145, 88);
        	this.addButton(g_ResourceManager.instructionsButton, 5, 140, 150);
    	}
    }

    this.hop = function(i)
    {
        g_GameObjectManager.shutdownAll();
        this.menu = new MainMenu().startupMainMenu(i);
    }
    
    /*this.gameOver = function()
    {
    	g_GameObjectManager.shutdownAll();
    	g_GameObjectManager.xScroll = 0;
    	g_GameObjectManager.yScroll = 0;
    	g_score = 0;
    	this.gameOver = new GameOver().startupGameOver();
    }*/
    
    //Adds a button to the screen with the given image and type index at the given coordinates
    this.addButton = function(image, type, x, y)
    {
    	this.buttons.push(new Button().startupButton(image, type, x, y));
    }
    	
	//Removes all copies from the array
	this.emptyArray = function()
	{
		g_Copies.splice(0, g_Copies.length);
		g_Copies.length = 0;
		g_Records.splice(0, g_Records.length);
		g_Records.length = 0;
	}
	
	//Removes all buttons from the screen
	this.emptyButtons = function()
	{
		this.buttons.splice(0, this.buttons.length);
		this.buttons.length = 0;
	}
}