/**
    A class to represent the level
    @Author Jonathan Saunders and Ethan White
    @Original <a href="mailto:matthewcasperson@gmail.com">Matthew Casperson</a>
    @class
*/
function Level()
{
    this.levelEnds = new Array();
    this.portalPath = null;
    this.goalItems = new Array();
    this.stage = null;
    this.passNum = 0; //Number of times player needs to succeed to go to next level
    
    //Starting coordinates of the player and copies
    this.startX = 0;
    this.startY = 0;


    // Initialises this object
    this.startupLevel = function(canvasWidth, canvasHeight)
    {    	
    	//Reset obstacle, scenery, and portal lists
    	g_Obstacles = new Array();
    	g_Scenery = new Array();
    	g_Portals = new Array();
    	this.portalPath = null;
    	
    	/*Set up level, depending on which one it is*/
    	switch (g_Level) {
    		
    		case 1: /*Present era, Level 1*/
    			this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stage, 0, 0, 1);
    			//new AnimatedGameObject().startupAnimatedGameObject(g_ResourceManager.textGlow, 450, -10, 15, 3, 3);
    			g_Clock = 10;
		        this.addLevelEnd(500, 60);
		        this.addTimetanium(134, 142);
		        this.passNum = 1;
		        this.startX = 500;
		        this.startY = 200;
		        break;
		    
		    case 2: /*Present era, Level 2*/
		   		this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stage, 0, 0, 1);
    			g_Clock = 5;
		   		this.addLevelEnd(30,60);
		   		this.addTimetanium(260, 110);
		   		this.passNum = 1;
		   		this.startX = 500;
		   		this.startY = 200;
		   		break;
		   		
		   	case 3: /*Present era, Level 3*/
		   		this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stage, 0, 0, 1);
    			g_Clock = 7;
		   		this.addLevelEnd(500, 60);
		   		this.addTimetanium(40, 60);
		   		this.addObstacle(g_ResourceManager.desk, 275, 90, 4);
		   		this.passNum = 1;
		   		this.startX = 500;
		   		this.startY = 200;
		   		break;
		   		
		   	case 4: /*Present era, Level 4*/
		   		this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stage, 0, 0, 1);
    			g_Clock = 7;
		   		this.addLevelEnd(100, 200);
		   		this.addTimetanium(300, 90);
		   		this.addObstacle(g_ResourceManager.desk, 500, 90, 4);
		   		this.addObstacle(g_ResourceManager.chemistry, 100, 85, 4);
		   		this.addObstacle(g_ResourceManager.waste, 300, 200, 4);
		   		this.passNum = 2;
		   		this.startX = 500;
		   		this.startY = 200;
		   		break;
		   		
		   	case 5: /*Present era, Level 5*/
		   		this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stage, 0, 0, 1);
    			g_Clock = 7;
		   		this.addLevelEnd(50, 250);
		   		this.addTimetanium(500, 60);
		   		this.addObstacle(g_ResourceManager.chemistry, 175, 70, 4);
		   		this.addObstacle(g_ResourceManager.chemistry, 380, 70, 4);
		   		this.addObstacle(g_ResourceManager.desk, 276, 90, 4);
		   		this.addObstacle(g_ResourceManager.desk, 290, 220, 4);
		   		this.addObstacle(g_ResourceManager.desk, 40, 120, 4);
		   		this.addObstacle(g_ResourceManager.desk, 135, 260, 4);
		   		this.passNum = 3;
		   		this.startX = 500;
		   		this.startY = 200;
		   		break;
		   		
		   	case 6: /*Present era, Level 6*/
		   		this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stage, 0, 0, 1);
    			g_Clock = 10;
		   		this.addLevelEnd(300, 130);
		   		this.addTimetanium(500, 50);
		   		this.passNum = 5;
		   		this.startX = 500;
		   		this.startY = 200;
		   		this.addObstacle(g_ResourceManager.chemistry, 40, 60, 4);
		   		this.addObstacle(g_ResourceManager.desk, 40, 330, 4);
		   		this.addObstacle(g_ResourceManager.desk, 300, 330, 4);
		   		this.addObstacle(g_ResourceManager.chair, 40, 290, 4);
		   		this.addObstacle(g_ResourceManager.chair, 415, 115, 4);
		   		this.addObstacle(g_ResourceManager.chair, 374, 74, 4);
		   		this.addObstacle(g_ResourceManager.chair, 349, 74, 4);
		   		this.addObstacle(g_ResourceManager.chair, 395, 180, 4);
		   		this.addObstacle(g_ResourceManager.chair, 275, 74, 4);
		   		this.addObstacle(g_ResourceManager.chair, 246, 69, 4);
		   		this.addObstacle(g_ResourceManager.chair, 220, 90, 4);
		   		this.addObstacle(g_ResourceManager.chair, 190, 100, 4);
		   		break;
		   		
		   	case 7: /*60s era, Level 1*/
		   		this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stage60s, 0, 0, 1);
		   		g_Clock = 7;
		   		this.portalPath = new Array(new Coordinate().startupCoordinate(30, 260));
		   		this.addLevelEnd(500, 50);
		   		this.addTimetanium(60, 70);
		   		this.passNum = 2;
		   		this.startX = 500;
		   		this.startY = 200;
		   		break;
		   		
		   	case 8: /*60s era, Level 2*/
		   		this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stage60s, 0, 0, 1);
		   		g_Clock = 7;
		   		this.portalPath = new Array(new Coordinate().startupCoordinate(30, 280));
		   		this.addLevelEnd(30, 60);
		   		this.addTimetanium(300, 180);
		   		this.addObstacle(g_ResourceManager.aquarium, 50, 130, 4);
		   		this.addObstacle(g_ResourceManager.aquarium, 50, 210, 4);
		   		this.addObstacle(g_ResourceManager.aquarium, 500, 75, 4);
		   		this.passNum = 2;
		   		this.startX = 500;
		   		this.startY = 200;
		   		break;
		   		
		   	case 9: /*60s era, Level 3*/
		   		this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stage60s, 0, 0, 1);
		   		g_Clock = 7;
		   		this.portalPath = new Array(new Coordinate().startupCoordinate(500, 200));
		   		this.addLevelEnd(30, 60);
		   		this.addTimetanium(300, 180);
		   		this.addObstacle(g_ResourceManager.aquarium, 100, 100, 4);
		   		this.addObstacle(g_ResourceManager.chemicals, 300, 110, 4);
		   		this.addObstacle(g_ResourceManager.teak_desk, 400, 150, 4);
		   		this.addObstacle(g_ResourceManager.chemicals, 90, 180, 4);
		   		this.addObstacle(g_ResourceManager.teak_desk, 160, 220, 4);
		   		this.passNum = 4;
		   		this.startX = 500;
		   		this.startY = 200;
		   		break;
		   		
		   	case 10: /*60s era, Level 4*/
		   		this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stage60s, 0, 0, 1);
		   		g_Clock = 7;
		   		this.addLevelEnd(100, 50);
		   		this.addLevelEnd(450, 50);
		   		this.addTimetanium(150, 300);
		   		this.addObstacle(g_ResourceManager.aquarium, 200, 50, 4);
		   		this.addObstacle(g_ResourceManager.teak_desk, 80, 200, 4);
		   		this.addObstacle(g_ResourceManager.chemicals, 70, 250, 4);
		   		this.passNum = 2;
		   		this.startX = 500;
		   		this.startY = 200;
		   		break;
		   		
		   	case 11: /*60s era, Level 5*/
		   		this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stage60s, 0, 0, 1);
		   		g_Clock = 8;
		   		this.addLevelEnd(200, 50);
		   		this.addLevelEnd(250, 240);
		   		this.addTimetanium(400, 260);
		   		this.addObstacle(g_ResourceManager.aquarium, 100, 90, 4);
		   		this.addObstacle(g_ResourceManager.aquarium, 500, 80, 4);
		   		this.addObstacle(g_ResourceManager.teak_desk, 300, 55, 4);
		   		this.addObstacle(g_ResourceManager.cooler, 200, 240, 4);
		   		this.passNum = 5;
		   		this.startX = 500;
		   		this.startY = 200;
		   		break;
		   		
		   	case 12: /*60s era, Level 6*/
		   		this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stage60s, 0, 0, 1);
		   		g_Clock = 15;
		   		this.portalPath = new Array(new Coordinate().startupCoordinate(30, 60));
		   		this.addLevelEnd(30, 240);
		   		this.portalPath = new Array(new Coordinate().startupCoordinate(150, 260));
		   		this.addLevelEnd(150, 80);
		   		this.portalPath = new Array(new Coordinate().startupCoordinate(270, 60));
		   		this.addLevelEnd(270, 240);
		   		this.portalPath = new Array(new Coordinate().startupCoordinate(390, 260));
		   		this.addLevelEnd(390, 80);
		   		this.addTimetanium(500, 50);
		   		this.addObstacle(g_ResourceManager.display, 440, 60, 4);
		   		this.addObstacle(g_ResourceManager.atomic_clock, 30, 160, 4);
		   		this.addObstacle(g_ResourceManager.cooler, 140, 50, 4);
		   		this.addObstacle(g_ResourceManager.teak_desk, 70, 300, 4);
		   		this.addObstacle(g_ResourceManager.roll_chair, 190, 185, 4);
		   		this.addObstacle(g_ResourceManager.aquarium, 330, 100, 4);
		   		this.addObstacle(g_ResourceManager.teak_desk, 360, 300, 4);
		   		this.passNum = 6;
		   		this.startX = 500;
		   		this.startY = 200;
		   		break;
		   	
		   	case 13: /*Medieval era, Level 1*/
		   		this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stageMedieval, 0, 0, 1);
		   		g_Clock = 7;
		   		this.addLevelEnd(500, 50);
		   		this.addTimetanium(370, 50);
		   		this.addObstacle(g_ResourceManager.stool, 230, 90, 4);
		   		this.addObstacle(g_ResourceManager.alchemy, 200, 130, 4);
		   		this.addObstacle(g_ResourceManager.cauldron, 200, 200, 4);
		   		this.addObstacle(g_ResourceManager.chest, 40, 120, 4);
		   		this.addObstacle(g_ResourceManager.chest, 40, 180, 4);
		   		this.addObstacle(g_ResourceManager.chest, 40, 240, 4);
		   		this.addObstacle(g_ResourceManager.crystal_ball, 450, 20, 4);
		   		this.addObstacle(g_ResourceManager.lectern, 450, 100, 4);
		   		this.addObstacle(g_ResourceManager.stool, 450, 160, 4);
		   		this.passNum = 3;
		   		switch(g_Copies.length)
		   		{
		   			case 2: case 3:
		   				this.startX = 80;
		   				this.startY = 65;
		   				break;
		   				
		   			default:
				   		this.startX = 500;
				   		this.startY = 200;
				   		break;
		   		}
		   		break;
		   		
		   	case 14: /*Medieval era, Level 2*/
		   		this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stageMedieval, 0, 0, 1);
		   		g_Clock = 5;
		   		this.portalPath = new Array(new Coordinate().startupCoordinate(500, 280));
		   		this.addLevelEnd(50, 50);
		   		this.addTimetanium(275, 165);
		   		this.passNum = 4;
		   		this.addObstacle(g_ResourceManager.crystal_ball, 490, 40, 4);
		   		this.addObstacle(g_ResourceManager.alchemy, 490, 100, 4);
		   		this.addObstacle(g_ResourceManager.chest, 60, 140, 4);
		   		this.addObstacle(g_ResourceManager.lectern, 60, 230, 4);
		   		this.addObstacle(g_ResourceManager.barrel, 170, 280, 4);
		   		switch(g_Copies.length)
		   		{
		   			case 1:
		   				this.startX = 300;
		   				this.startY = 125;
		   				break;
		   			
		   			case 2: case 3:
		   				this.startX = 250;
		   				this.startY = 280;
		   				break;
		   				
		   			case 4:
		   				this.startX = 75;
		   				this.startY = 280;
		   				break;
		   				
		   			default:
		   				this.startX = 500;
		   				this.startY = 200;
		   				break;
		   		}
		   		break;
		   		
		   	case 15: /*Medieval era, Level 3*/
		   		this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stageMedieval, 0, 0, 1);
		   		g_Clock = 7;
		   		this.passNum = 5;
		   		this.addLevelEnd(50, 50);
		   		this.addLevelEnd(520, 280);
		   		this.addTimetanium(320, 200);
		   		this.addObstacle(g_ResourceManager.alchemy, 180, 260, 4);
		   		this.addObstacle(g_ResourceManager.barrel, 35, 150, 4);
		   		this.addObstacle(g_ResourceManager.lectern, 400, 50, 4);
		   		this.addObstacle(g_ResourceManager.chest, 480, 50, 4);
		   		this.addObstacle(g_ResourceManager.cauldron, 500, 100, 4);
		   		switch(g_Copies.length)
		   		{
		   			case 0: case 2: case 4:
		   				this.startX = 480;
		   				this.startY = 200;
		   				break;
		   				
		   			case 1: case 3:
		   				this.startX = 130;
		   				this.startY = 75;
		   				break;
		   				
		   			case 5:
		   				this.startX = 60;
		   				this.startY = 310;
		   				break;
		   		}
		   		break;
		   		
		   	case 16: /*Medieval era, Level 4*/
		   		this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stageMedieval, 0, 0, 1);
		   		g_Clock = 8;
		   		this.passNum = 6;
		   		this.addTimetanium(500, 50);
		   		this.portalPath = new Array(new Coordinate().startupCoordinate(500, 50));
		   		this.addLevelEnd(100, 50);
		   		this.addLevelEnd(130, 270);
		   		this.portalPath = new Array(new Coordinate().startupCoordinate(380, 50));
		   		this.addLevelEnd(380, 250);
		   		this.addObstacle(g_ResourceManager.alchemy, 300, 100, 4);
		   		this.addObstacle(g_ResourceManager.alchemy, 300, 260, 4);
		   		this.addObstacle(g_ResourceManager.crystal_ball, 500, 170, 4);
		   		this.addObstacle(g_ResourceManager.cauldron, 50, 170, 4);
		   		switch (g_Copies.length)
		   		{
		   			case 0: case 3:
		   				this.startX = 500;
		   				this.startY = 250;
		   				break;
		   				
		   			case 1: case 4: case 6:
		   				this.startX = 50;
		   				this.startY = 50;
		   				break;
		   				
		   			case 2: case 5:
		   				this.startX = 65;
		   				this.startY = 250;
		   				break;
		   		}
		   		break;
		   		
		   	case 17: /*Medieval era, Level 5*/
		   		this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stageMedieval, 0, 0, 1);
		   		g_Clock = 6;
		   		this.passNum = 3;
		   		this.addTimetanium(430, 260);
		   		this.portalPath = new Array(new Coordinate().startupCoordinate(50, 265));
		   		this.addLevelEnd(520, 265);
		   		this.portalPath = new Array(new Coordinate().startupCoordinate(50, 195));
		   		this.addLevelEnd(520, 195);
		   		this.portalPath = new Array(new Coordinate().startupCoordinate(50, 125));
		   		this.addLevelEnd(520, 125);
		   		this.portalPath = new Array(new Coordinate().startupCoordinate(50, 55));
		   		this.addLevelEnd(520, 55);
		   		this.addObstacle(g_ResourceManager.stool, 370, 300, 4);
		   		this.addObstacle(g_ResourceManager.chest, 350, 250, 4);
		   		this.addObstacle(g_ResourceManager.stool, 270, 245, 4);
		   		this.addObstacle(g_ResourceManager.stool, 310, 245, 4);
		   		this.addObstacle(g_ResourceManager.chest, 210, 230, 4);
		   		this.addObstacle(g_ResourceManager.crystal_ball, 230, 170, 4);
		   		this.addObstacle(g_ResourceManager.barrel, 90, 210, 4);
		   		this.addObstacle(g_ResourceManager.barrel, 90, 150, 4);
		   		this.addObstacle(g_ResourceManager.lectern, 90, 60, 4);
		   		this.addObstacle(g_ResourceManager.lectern, 130, 60, 4);
		   		this.addObstacle(g_ResourceManager.alchemy, 400, 60, 4);
		   		switch(g_Copies.length)
		   		{
		   			case 0:
		   				this.startX = 430;
		   				this.startY = 260;
		   				break;
		   			
		   			case 1:
		   				this.startX = 300;
		   				this.startY = 175;
		   				break;
		   				
		   			case 2:
		   				this.startX = 250;
		   				this.startY = 270;
		   				break;
		   				
		   			case 3:
		   				this.startX = 50;
		   				this.startY = 80;
		   				break;
		   		}
		   		break;
		   		
		   	case 18: /*Medieval era, Level 6*/
		   		this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stageMedieval, 0, 0, 1);
		   		g_Clock = 7;
		   		this.passNum = 6;
		   		this.addTimetanium(400, 180);
		   		this.portalPath = new Array(new Coordinate().startupCoordinate(520, 50));
		   		this.addLevelEnd(65, 290);
		   		this.portalPath = new Array(new Coordinate().startupCoordinate(500, 290));
		   		this.addLevelEnd(40, 40);
		   		this.portalPath = new Array(new Coordinate().startupCoordinate(340, 290));
		   		this.addLevelEnd(340, 50);
		   		this.addObstacle(g_ResourceManager.crystal_ball, 60, 180, 4);
		   		this.addObstacle(g_ResourceManager.barrel, 200, 50, 4);
		   		this.addObstacle(g_ResourceManager.lectern, 240, 300, 4);
		   		this.addObstacle(g_ResourceManager.crystal_ball, 420, 300, 4);
		   		this.addObstacle(g_ResourceManager.barrel, 420, 50, 4);
		   		this.addObstacle(g_ResourceManager.lectern, 540, 160, 4);
		   		switch(g_Copies.length)
		   		{
		   			case 0:
		   				this.startX = 500;
		   				this.startY = 260;
		   				break;
		   				
		   			case 1:
		   				this.startX = 70;
		   				this.startY = 110;
		   				break;
		   				
		   			case 2:
		   				this.startX = 260;
		   				this.startY = 50;
		   				break;
		   				
		   			case 3:
		   				this.startX = 460;
		   				this.startY = 50;
		   				break;
		   				
		   			case 4:
		   				this.startX = 520;
		   				this.startY = 200;
		   				break;
		   				
		   			case 5:
		   				this.startX = 75;
		   				this.startY = 230;
		   				break;
		   				
		   			case 6:
		   				this.startX = 180;
		   				this.startY = 280;
		   				break;
		   		}
		   		break;
		   		
		   	case 19: /*Prehistoric era, Level 1*/
		   		this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stagePrehistoric, 0, 0, 1);
		   		g_Clock = 7;
		   		this.passNum = 4;
		   		this.addTimetanium(320, 200);
		   		this.addLevelEnd(60, 50);
		   		this.addLevelEnd(60, 270);
		   		this.addObstacle(g_ResourceManager.dino_skull, 400, 60, 4);
		   		this.addObstacle(g_ResourceManager.fire, 70, 220, 4);
		   		switch(g_Copies.length)
		   		{
		   			case 0:
		   				this.startX = 520;
		   				this.startY = 250;
		   				break;
		   				
		   			case 1:
		   				this.startX = 520;
		   				this.startY = 70;
		   				this.addObstacle(g_ResourceManager.alchemy, 250, 100, 4);
		   				break;
		   			
		   			case 2:
		   				this.startX = 520;
		   				this.startY = 70;
		   				this.addObstacle(g_ResourceManager.alchemy, 250, 100, 4);
		   				this.addObstacle(g_ResourceManager.atomic_clock, 130, 270, 4);
		   				break;
		   				
		   			case 3: case 4:
		   				this.startX = 520;
		   				this.startY = 250;
		   				this.addObstacle(g_ResourceManager.alchemy, 250, 100, 4);
		   				this.addObstacle(g_ResourceManager.atomic_clock, 130, 270, 4);
		   				this.addObstacle(g_ResourceManager.chemistry, 490, 100, 4);
		   				break;
		   		}
		   		break;
		   		
		   	case 20: /*Prehistoric era, Level 2*/
		   		this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stagePrehistoric, 0, 0, 1);
		   		g_Clock = 9;
		   		this.passNum = 6;
		   		this.addTimetanium(400, 280);
		   		this.addLevelEnd(300, 30);
		   		this.addLevelEnd(300, 95);
		   		this.addLevelEnd(300, 160);
		   		this.addLevelEnd(300, 225);
		   		this.addLevelEnd(300, 290);
		   		this.addObstacle(g_ResourceManager.fire, 460, 60, 4);
		   		switch(g_Copies.length)
		   		{
		   			case 0:
		   				this.startX = 520;
		   				this.startY = 250;
		   				break;
		   				
		   			case 1:
		   				this.startX = 75;
		   				this.startY = 250;
		   				break;
		   				
		   			case 2:
		   				this.startX = 520;
		   				this.startY = 160;
		   				break;
		   				
		   			case 3:
		   				this.startX = 75;
		   				this.startY = 160;
		   				this.addObstacle(g_ResourceManager.aquarium, 230, 90, 4);
		   				this.addObstacle(g_ResourceManager.aquarium, 230, 160, 4);
		   				this.addObstacle(g_ResourceManager.aquarium, 230, 230, 4);
		   				break;
		   				
		   			case 4:
		   				this.startX = 520;
		   				this.startY = 75;
		   				this.addObstacle(g_ResourceManager.barrel, 370, 230, 4);
		   				this.addObstacle(g_ResourceManager.aquarium, 230, 90, 4);
		   				this.addObstacle(g_ResourceManager.aquarium, 230, 160, 4);
		   				this.addObstacle(g_ResourceManager.aquarium, 230, 230, 4);
		   				break;
		   				
		   			case 5:
		   				this.startX = 520;
		   				this.startY = 250;
		   				this.addObstacle(g_ResourceManager.barrel, 370, 230, 4);
		   				this.addObstacle(g_ResourceManager.aquarium, 230, 90, 4);
		   				this.addObstacle(g_ResourceManager.aquarium, 230, 160, 4);
		   				this.addObstacle(g_ResourceManager.aquarium, 230, 230, 4);
		   				break;
		   				
		   			case 6:
		   				this.startX = 75;
		   				this.startY = 75;
		   				this.addObstacle(g_ResourceManager.barrel, 370, 230, 4);
		   				this.addObstacle(g_ResourceManager.aquarium, 230, 90, 4);
		   				this.addObstacle(g_ResourceManager.aquarium, 230, 160, 4);
		   				this.addObstacle(g_ResourceManager.aquarium, 230, 230, 4);
		   				break;
		   		}
		   		break;
		   		
		   	case 21: /*Prehistoric era, Level 3*/
		   		this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stagePrehistoric, 0, 0, 1);
		   		g_Clock = 8;
		   		this.passNum = 7;
		   		this.addTimetanium(420, 130);
		   		this.portalPath = new Array(new Coordinate().startupCoordinate(420, 50));
		   		this.addLevelEnd(50, 50);
		   		this.portalPath = new Array(new Coordinate().startupCoordinate(520, 200));
		   		this.addLevelEnd(520, 50);
		   		this.addObstacle(g_ResourceManager.fire, 360, 150, 4);
		   		switch (g_Copies.length)
		   		{
		   			case 0:
		   				this.startX = 520;
		   				this.startY = 250;
		   				break;
		   				
		   			case 1:
		   				this.startX = 125;
		   				this.startY = 250;
		   				this.addObstacle(g_ResourceManager.cooler, 360, 40, 4);
		   				break;
		   				
		   			case 2:
		   				this.startX = 520;
		   				this.startY = 250;
		   				this.addObstacle(g_ResourceManager.cooler, 360, 40, 4);
		   				break;
		   				
		   			case 3:
		   				this.startX = 125;
		   				this.startY = 250;
		   				this.addObstacle(g_ResourceManager.cooler, 360, 40, 4);
		   				this.addObstacle(g_ResourceManager.chest, 360, 100, 4);
		   				this.addObstacle(g_ResourceManager.tipped_chair, 250, 200, 4);
		   				break;
		   				
		   			case 4:
		   				this.startX = 520;
		   				this.startY = 250;
		   				this.addObstacle(g_ResourceManager.cooler, 360, 40, 4);
		   				this.addObstacle(g_ResourceManager.chest, 360, 100, 4);
		   				this.addObstacle(g_ResourceManager.chair, 250, 200, 4);
		   				break;
		   				
		   			case 5: case 6:
		   				this.startX = 125;
		   				this.startY = 250;
		   				this.addObstacle(g_ResourceManager.cooler, 360, 40, 4);
		   				this.addObstacle(g_ResourceManager.chest, 360, 100, 4);
		   				this.addObstacle(g_ResourceManager.chair, 250, 200, 4);
		   				this.addObstacle(g_ResourceManager.atomic_clock, 360, 200, 4);
		   				this.addObstacle(g_ResourceManager.aquarium, 360, 270, 4);
		   				this.addObstacle(g_ResourceManager.chemistry, 125, 125, 4);
		   				this.addObstacle(g_ResourceManager.waste, 60, 200, 4);
		   				break;
		   				
		   			case 7:
		   				this.startX = 125;
		   				this.startY = 250;
		   				this.addObstacle(g_ResourceManager.cooler, 360, 40, 4);
		   				this.addObstacle(g_ResourceManager.chest, 360, 100, 4);
		   				this.addObstacle(g_ResourceManager.chair, 250, 200, 4);
		   				this.addObstacle(g_ResourceManager.atomic_clock, 360, 200, 4);
		   				this.addObstacle(g_ResourceManager.aquarium, 360, 270, 4);
		   				this.addObstacle(g_ResourceManager.chemistry, 125, 125, 4);
		   				this.addObstacle(g_ResourceManager.waste, 60, 200, 4);
		   				this.addObstacle(g_ResourceManager.desk, 180, 90, 4);
		   				this.addObstacle(g_ResourceManager.lectern, 260, 70, 4);
		   				break;
		   		}
		   		break;
		   		
		   	case 22: /*Prehistoric era, Level 4*/
		   		this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stagePrehistoric, 0, 0, 1);
		   		g_Clock = 9;
		   		this.passNum = 6;
		   		this.addTimetanium(440, 230);
		   		this.portalPath = new Array(new Coordinate().startupCoordinate(280, 50));
		   		this.addLevelEnd(50, 50);
		   		this.addObstacle(g_ResourceManager.desk, 200, 220, 4);
		   		this.addObstacle(g_ResourceManager.fire, 240, 270, 4);
		   		this.addObstacle(g_ResourceManager.fire, 40, 200, 4);
		   		this.addObstacle(g_ResourceManager.fire, 80, 200, 4);
		   		this.addObstacle(g_ResourceManager.fire, 120, 160, 4);
		   		this.addObstacle(g_ResourceManager.fire, 200, 80, 4);
		   		this.addTimedObstacle(g_ResourceManager.barrel, 360, 40, 1);
		   		this.addTimedObstacle(g_ResourceManager.barrel, 360, 120, 1);
		   		this.addTimedObstacle(g_ResourceManager.waste, 360, 80, 2);
		   		this.addTimedObstacle(g_ResourceManager.waste, 360, 160, 2);
		   		this.addTimedObstacle(g_ResourceManager.chair, 160, 260, 3);
		   		this.addTimedObstacle(g_ResourceManager.barrel, 360, 200, 4);
		   		this.addTimedObstacle(g_ResourceManager.barrel, 360, 280, 4);
		   		this.addTimedObstacle(g_ResourceManager.tipped_chair, 160, 320, 4);
		   		this.addTimedObstacle(g_ResourceManager.waste, 360, 240, 5);
		   		this.addTimedObstacle(g_ResourceManager.roll_chair, 160, 120, 5);
		   		this.addTimedObstacle(g_ResourceManager.stool, 200, 120, 6);
		   		this.addTimedObstacle(g_ResourceManager.waste, 360, 320, 7);
		   		switch (g_Copies.length)
		   		{
		   			case 0:
		   				this.startX = 520;
		   				this.startY = 250;
		   				break;
		   				
		   			case 1:
		   				this.startX = 520;
		   				this.startY = 190;
		   				break;
		   				
		   			case 2:
		   				this.startX = 520;
		   				this.startY = 130;
		   				break;
		   				
		   			case 3:
		   				this.startX = 520;
		   				this.startY = 70;
		   				break;
		   				
		   			case 4: case 5: case 6:
		   				this.startX = 80;
		   				this.startY = 300;
		   				break;
		   		}
		   		break;
		   		
		   	case 23: /*Prehistoric era, Level 5*/
		   		this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stagePrehistoric, 0, 0, 1);
		   		g_Clock = 10;
		   		this.passNum = 7;
		   		this.addTimetanium(260, 170);
		   		this.addLevelEnd(50, 280);
		   		this.addObstacle(g_ResourceManager.dino_skull, 120, 220, 4);
		   		this.addObstacle(g_ResourceManager.desk, 140, 140, 4);
		   		this.addObstacle(g_ResourceManager.alchemy, 300, 220, 4);
		   		this.addObstacle(g_ResourceManager.chair, 380, 220, 4);
		   		this.addObstacle(g_ResourceManager.chemistry, 420, 220, 4);
		   		this.addObstacle(g_ResourceManager.cooler, 460, 160, 4);
		   		this.addObstacle(g_ResourceManager.stool, 305, 130, 4);
		   		this.addTimedObstacle(g_ResourceManager.crystal_ball, 460, 40, 3);
		   		this.addTimedObstacle(g_ResourceManager.lectern, 380, 100, 5);
		   		this.addTimedObstacle(g_ResourceManager.waste, 300, 40, 6);
		   		this.addTimedObstacle(g_ResourceManager.cauldron, 300, 160, 6);
		   		this.addTimedObstacle(g_ResourceManager.desk, 220, 140, 7);
		   		this.addTimedObstacle(g_ResourceManager.roll_chair, 140, 100, 7);
		   		this.addTimedObstacle(g_ResourceManager.barrel, 260, 240, 8);
		   		this.addTimedObstacle(g_ResourceManager.barrel, 200, 310, 8);
		   		this.addTimedObstacle(g_ResourceManager.barrel, 80, 40, 8);
		   		this.addTimedObstacle(g_ResourceManager.barrel, 40, 140, 8);
		   		this.addTimedObstacle(g_ResourceManager.teak_desk, 30, 220, 9);
		   		switch (g_Copies.length)
		   		{
		   			case 0:
		   				this.startX = 520;
		   				this.startY = 250;
		   				break;
		   			
		   			case 1:
		   				this.startX = 340;
		   				this.startY = 160;
		   				this.addObstacle(g_ResourceManager.tipped_chair, 460, 280, 4);
		   				this.addObstacle(g_ResourceManager.tipped_chair, 460, 320, 4);
		   				this.addObstacle(g_ResourceManager.aquarium, 300, 280, 4);
		   				break;
		   				
		   			case 2:
		   				this.startX = 220;
		   				this.startY = 70;
		   				this.addObstacle(g_ResourceManager.tipped_chair, 460, 280, 4);
		   				this.addObstacle(g_ResourceManager.tipped_chair, 460, 320, 4);
		   				this.addObstacle(g_ResourceManager.aquarium, 300, 280, 4);
		   				break;
		   				
		   			case 3:
		   				this.startX = 420;
		   				this.startY = 100;
		   				this.addObstacle(g_ResourceManager.tipped_chair, 460, 280, 4);
		   				this.addObstacle(g_ResourceManager.tipped_chair, 460, 320, 4);
		   				this.addObstacle(g_ResourceManager.aquarium, 300, 280, 4);
		   				break;
		   				
		   			case 4:
		   				this.startX = 460;
		   				this.startY = 100;
		   				this.addObstacle(g_ResourceManager.tipped_chair, 460, 280, 4);
		   				this.addObstacle(g_ResourceManager.tipped_chair, 460, 320, 4);
		   				this.addObstacle(g_ResourceManager.aquarium, 300, 280, 4);
		   				break;
		   				
		   			case 5:
		   				this.startX = 550;
		   				this.startY = 50;
		   				this.addObstacle(g_ResourceManager.tipped_chair, 460, 280, 4);
		   				this.addObstacle(g_ResourceManager.tipped_chair, 460, 320, 4);
		   				this.addObstacle(g_ResourceManager.aquarium, 300, 280, 4);
		   				break;
		   				
		   			case 6:
		   				this.startX = 550;
		   				this.startY = 180;
		   				this.addObstacle(g_ResourceManager.tipped_chair, 460, 280, 4);
		   				this.addObstacle(g_ResourceManager.tipped_chair, 460, 320, 4);
		   				this.addObstacle(g_ResourceManager.aquarium, 300, 280, 4);
		   				break;
		   				
		   			case 7:
		   				this.startX = 520;
		   				this.startY = 250;
		   				this.addObstacle(g_ResourceManager.tipped_chair, 460, 280, 4);
		   				this.addObstacle(g_ResourceManager.tipped_chair, 460, 320, 4);
		   				this.addObstacle(g_ResourceManager.aquarium, 300, 280, 4);
		   				break;
		   		}
		   		break;
		   		
		   	case 24: /*Prehistoric era, Level 6 - THE LAST LEVEL!!!omg!!*/
		   		this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stagePrehistoric, 0, 0, 1);
		   		g_Clock = 10;
		   		this.passNum = 11;
		   		this.addTimetanium(75, 120);
		   		this.addLevelEnd(500, 40);
		   		this.addTimedPortal(new Array(new Coordinate().startupCoordinate(50, 270)), 50, 50, 2);
		   		this.addTimedPortal(new Array(new Coordinate().startupCoordinate(50, 50)), 50, 270, 3);
		   		this.addTimedPortal(new Array(new Coordinate().startupCoordinate(150, 80)), 440, 230, 5);
		   		this.addTimedObstacle(g_ResourceManager.dino_skull, 150, 120, 3);
		   		this.addTimedObstacle(g_ResourceManager.chest, 120, 320, 5);
		   		this.addTimedObstacle(g_ResourceManager.atomic_clock, 280, 310, 7);
		   		this.addTimedObstacle(g_ResourceManager.teak_desk, 320, 200, 2);
		   		this.addTimedObstacle(g_ResourceManager.tipped_chair, 300, 110, 7);
		   		this.addTimedObstacle(g_ResourceManager.aquarium, 300, 30, 2);
		   		switch(g_Copies.length)
		   		{
		   			case 0:
		   				this.startX = 520;
		   				this.startY = 250;
		   				break;
		   				
		   			case 1:
		   				this.startX = 150;
		   				this.startY = 50;
		   				break;
		   				
		   			case 2:
		   				this.startX = 150;
		   				this.startY = 250;
				   		this.addTimedObstacle(g_ResourceManager.dino_skull, 440, 40, 2);
				   		this.addTimedObstacle(g_ResourceManager.desk, 500, 110, 4);
		   				break;
		   				
		   			case 3:
		   				this.startX = 230;
		   				this.startY = 50;
		   				this.addTimedObstacle(g_ResourceManager.dino_skull, 440, 40, 2);
				   		this.addTimedObstacle(g_ResourceManager.desk, 500, 110, 4);
		   				break;
		   				
		   			case 4:
		   				this.startX = 230;
		   				this.startY = 250;
		   				this.addTimedObstacle(g_ResourceManager.dino_skull, 440, 40, 2);
				   		this.addTimedObstacle(g_ResourceManager.desk, 500, 110, 4);
		   				break;
		   				
		   			case 5:
		   				this.startX = 310;
		   				this.startY = 50;
		   				this.addTimedObstacle(g_ResourceManager.dino_skull, 440, 40, 2);
				   		this.addTimedObstacle(g_ResourceManager.desk, 500, 110, 4);
		   				break;
		   				
		   			case 6:
		   				this.startX = 310;
		   				this.startY = 250;
		   				this.addTimedObstacle(g_ResourceManager.dino_skull, 440, 40, 2);
				   		this.addTimedObstacle(g_ResourceManager.desk, 500, 110, 4);
		   				break;
		   				
		   			case 7:
		   				this.startX = 390;
		   				this.startY = 50;
		   				this.addTimedObstacle(g_ResourceManager.dino_skull, 440, 40, 2);
				   		this.addTimedObstacle(g_ResourceManager.desk, 500, 110, 4);
		   				break;
		   				
		   			case 8:
		   				this.startX = 390;
		   				this.startY = 250;
		   				this.addTimedObstacle(g_ResourceManager.dino_skull, 440, 40, 2);
				   		this.addTimedObstacle(g_ResourceManager.desk, 500, 110, 4);
		   				break;
		   				
		   			case 9:
		   				this.startX = 520;
		   				this.startY = 180;
		   				this.addTimedObstacle(g_ResourceManager.dino_skull, 440, 40, 2);
				   		this.addTimedObstacle(g_ResourceManager.desk, 500, 110, 4);
		   				break;
		   				
		   			case 10:
		   				this.startX = 520;
		   				this.startY = 110;
		   				this.addTimedObstacle(g_ResourceManager.dino_skull, 440, 40, 2);
				   		this.addTimedObstacle(g_ResourceManager.desk, 500, 110, 4);
		   				break;
		   				
		   			case 11:
		   				this.startX = 520;
		   				this.startY = 250;
		   				this.addTimedObstacle(g_ResourceManager.dino_skull, 440, 40, 2);
				   		this.addTimedObstacle(g_ResourceManager.desk, 500, 110, 4);
		   				break;
		   		}
		   		break;
		   		
		   	case g_LastLevel: /*The REAL last level of the game; interactive cutscene*/
		   		this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stagePrehistoric, 0, 0, 1);
		   		this.addLevelEnd(50, 50);
		   		this.addTimetanium(150, 50);
		   		this.addObstacle(g_ResourceManager.atomic_clock, 440, 300, 4);
		   		this.addObstacle(g_ResourceManager.waste, 530, 220, 4);
		   		this.addObstacle(g_ResourceManager.chair, 490, 220, 4);
		   		this.addObstacle(g_ResourceManager.tipped_chair, 450, 220, 4);
		   		this.addObstacle(g_ResourceManager.roll_chair, 410, 220, 4);
		   		this.addTimedObstacle(g_ResourceManager.barrel, 370, 220, .5);
		   		this.addTimedObstacle(g_ResourceManager.cauldron, 320, 220, .5);
		   		this.addTimedObstacle(g_ResourceManager.stool, 280, 220, .5);
		   		this.addTimedObstacle(g_ResourceManager.crystal_ball, 280, 260, .5);
		   		this.addTimedObstacle(g_ResourceManager.fire, 230, 220, 1.25);
		   		this.addTimedObstacle(g_ResourceManager.chest, 170, 220, 1.25);
		   		this.addTimedObstacle(g_ResourceManager.lectern, 180, 300, 1.25);
		   		this.addTimedObstacle(g_ResourceManager.cooler, 130, 220, 1.5);
		   		this.addTimedObstacle(g_ResourceManager.aquarium, 70, 220, 1.5);
		   		this.addTimedObstacle(g_ResourceManager.dino_skull, 35, 120, 2.5);
		   		this.addTimedObstacle(g_ResourceManager.teak_desk, 110, 120, 2.75);
		   		this.addTimedObstacle(g_ResourceManager.alchemy, 190, 120, 3);
		   		this.addTimedObstacle(g_ResourceManager.chemistry, 270, 120, 3.25);
		   		this.addTimedObstacle(g_ResourceManager.desk, 350, 120, 3.5);
		   		this.addTimedObstacle(g_ResourceManager.chemicals, 430, 120, 3.75);
		   		this.startX = 520;
		   		this.startY = 280;
		   		break;
		   	
		    default: /*Unused level index*/
		   		this.stage = new VisualGameObject().startupVisualGameObject(g_ResourceManager.stagePrehistoric, 0, 0, 4);
		   		g_Clock = 1000;
		   		this.addTimetanium(500, 50);
		   		this.passNum = 6;
		   		this.startX = 500;
		   		this.startY = 200;
		   		/*
		   		if (g_GameObjectManager.isMobile)
		   			window.location = "http://www.surveymonkey.com/s/YBBM6M7";
		   		else
		   			window.location = "http://www.surveymonkey.com/s/VRRDLH6";*/
		   		break;
       }
	
        return this;
    }

	//Add an exit portal at given coordinates
    this.addLevelEnd = function(x, y)
    {
    	var port = new LevelEndPost().startupLevelEndPost(g_ResourceManager.greyPortal, x, y, 6);
    	if (this.portalPath != null)
    	{
    		for (var i = 0; i < this.portalPath.length; i++)
    		{
    			port.path.push(this.portalPath[i]);
    		}
    		port.moving = true;
    	}
    	g_Portals.push(port);
    }
    
    //Add a portal with the given path at the given coordinates after the given amount of seconds
    this.addTimedPortal = function(path, x, y, time)
    {
    	var port = new TimedPortal().startupTimedPortal(path, x, y, time, this);
    }
    
    //Add a Timetanium at given coordinates
    this.addTimetanium = function(x, y)
    {
    	new Powerup().startupPowerup(10, g_ResourceManager.timetanium, x, y, 5, 1, 1);
    	
    }
    
    //Add an obstacle with the given image at the given coordinates and given depth level
    this.addObstacle = function(image, x, y, level)
    {
    	var obs = new VisualGameObject().startupVisualGameObject(image, x, y, level);
    	g_Obstacles.push(obs);
    }
    
    //Add an animated obstacle with the given image at the given coordinates and given depth level
    this.addAnimatedObstacle = function(image, x, y, level, framecount, fps)
    {
    	var obs = new AnimatedGameObject().startupAnimatedGameObject(image, x, y, level, framecount, fps);
    	g_Obstacles.push(obs);
    }
    
    //Add an obstacle with the given image at the given coordinates after the given amount of seconds
    this.addTimedObstacle = function(image, x, y, time)
    {
    	var obs = new TimedObstacle().startupTimedObstacle(image, x, y, time, this);
    }
    
    //Add an obstacle with the given image at the given coordinates and given depth level
    this.addScenery = function(image, x, y, level)
    {
    	var obj = new VisualGameObject().startupVisualGameObject(image, x, y, level);
    	g_Scenery.push(obj);
    }
    
    /* Goes to next level*/
   this.nextLevel = function()
   {
   		g_Level++;
   }
   
   /**
    * Changes level to specified number
    * @param level			level to jump to
    */
   this.changeLevel = function(level)
   {
   		g_Level = level;
   }
}