/**
    Displays and updates some text
    @Author Jonathan Saunders
    @class
*/
function Text()
{
	this.x = 0;
	this.y = 0;
	
	this.label;
	this.data;
	this.time;

	//Initializes this object
	this.startupText = function(newX, newY, newLabel, newData)
	{
        this.x = newX;
		this.y = newY;
		this.label = newLabel;
		this.data = newData;
		
        this.startupGameObject(this.x, this.y, 12);
		
		return this;
	}
	
    /*  Updates the object
        @param dt The time since the last frame in seconds
        @param context The drawing context
        @param xScroll The global scrolling value of the x axis
        @param yScroll The global scrolling value of the y axis  */
    this.draw = function (/**Number*/ dt, /**CanvasRenderingContext2D*/context, /**Number*/ xScroll, /**Number*/ yScroll)
    {
    	var temp = this.data;
    	
	    context.strokeStyle="#000000";
	    context.fillStyle="#85f4aa";
	    context.font = 20 * g_RatioX + "px Trebuchet MS";
	    
	    if ((this.label == "Time: ") || (this.label == "Returning to title screen in: ")) {
	    context.font = 25 * g_RatioX + "px Trebuchet MS";
	    	this.updateData(dt);
	   		temp = Math.round(this.data*10)/10;
	   		if (temp <= 3)
	   			context.strokeStyle="#FF0000";
			if (temp <= 3)
				context.fillStyle="#FF0000";
	   }
	    
	    context.strokeText(this.label + temp, this.x, this.y);
	    context.fillText(this.label + temp, this.x, this.y);
    }

    
    this.updateData = function(dt)
    {
	    if (this.data <= 0)
		{
    		//Plays fail sound (start and end positions, can be found in SoundManager)
    		g_SoundManager.playSound(3.590, 4.605);
    		
	    	g_Records.pop();
			g_Copies.pop();
			g_ApplicationManager.hop(3);
		}
	    	
    	var tempdata = this.data - dt;
    	this.data = tempdata;
    }

    this.shutdownText = function()
    {
        this.shutdownGameObject();
    }

    this.shutdown = function()
    {
        this.shutdownText();
    }
    
}

Text.prototype = new GameObject;