/*
 * Portal that appears after a certain amount of time
 */

function TimedPortal()
{
	//The amount of time until this object enters the game
	this.timer = 0;
	
	//The path this portal will follow, if any
	this.path = null;
	
	//A reference to the level currently being played
	this.level = null;
	
	//This animation will be used when created and then destroyed when completed
	this.anim = null;
	
	//Whether or not the animation has completed
	this.animated = false;
	
	this.startupTimedPortal = function(path, xCoord, yCoord, timer, level)
	{
		this.x = xCoord;
		this.y = yCoord;
		this.path = path;
		this.timer = timer;
		this.level = level;
		this.startupGameObject(this.x, this.y, 4);
	}
	
	this.update = function(dt, context, xScroll, yScroll)
	{
		if ((this.timer <= .15) && (!this.animated))
		{
			//create the animation
			this.anim = new AnimatedGameObject().startupAnimatedGameObject(g_ResourceManager.portIn, this.x-(1120/4/2)+(70/2), this.y-300+(70/2), 20, 4, 30);
			
			this.animated = true;
		}
		
		if (this.timer <= 0)
		{
			//end the animation
	        this.anim.shutdown();
	        
			this.level.portalPath = this.path;
			this.level.addLevelEnd(this.x, this.y);
			this.shutdown();
		}
		else this.timer -= dt;
	}
}

TimedPortal.prototype = new GameObject;